6 # We don't use a secret keyring, of course, but gpg panics and
7 # implodes if there isn't one available
8 SECRETKEYRING
="$(mktemp)"
9 trap "rm -f '${SECRETKEYRING}'" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
10 GPG_CMD
="gpg --ignore-time-conflict --no-options --no-default-keyring --secret-keyring ${SECRETKEYRING}"
12 if [ "$(id -u)" -eq 0 ]; then
13 # we could use a tmpfile here too, but creation of this tends to be time-consuming
14 eval $(apt-config shell TRUSTDBDIR Dir::Etc/d)
15 GPG_CMD
="$GPG_CMD --trustdb-name ${TRUSTDBDIR}/trustdb.gpg"
21 ARCHIVE_KEYRING_URI
=""
22 #MASTER_KEYRING=/usr/share/keyrings/debian-master-keyring.gpg
23 #ARCHIVE_KEYRING_URI=http://ftp.debian.org/debian/debian-archive-keyring.gpg
25 ARCHIVE_KEYRING
=/usr
/share
/keyrings
/debian
-archive-keyring.gpg
26 REMOVED_KEYS
=/usr
/share
/keyrings
/debian
-archive-removed-keys.gpg
29 if [ "$(id -u)" -ne 0 ]; then
30 echo >&1 "ERROR: This command can only be used by root."
35 # gpg defaults to mode 0600 for new keyrings. Create one with 0644 instead.
38 if ! [ -e "$path" ]; then
45 add_keys_with_verify_against_master_keyring
() {
49 if [ ! -f "$ADD_KEYRING" ]; then
50 echo "ERROR: '$ADD_KEYRING' not found"
53 if [ ! -f "$MASTER" ]; then
54 echo "ERROR: '$MASTER' not found"
58 # when adding new keys, make sure that the archive-master-keyring
60 # all keys that are exported must have a valid signature
61 # from a key in the $distro-master-keyring
62 add_keys
=`$GPG_CMD --keyring $ADD_KEYRING --with-colons --list-keys | grep ^pub | cut -d: -f5`
63 master_keys
=`$GPG_CMD --keyring $MASTER --with-colons --list-keys | grep ^pub | cut -d: -f5`
64 for add_key
in $add_keys; do
66 for master_key
in $master_keys; do
67 if $GPG_CMD --keyring $ADD_KEYRING --list-sigs --with-colons $add_key | grep ^sig
| cut
-d: -f5 | grep -q $master_key; then
68 $GPG_CMD --quiet --batch --keyring $ADD_KEYRING --export $add_key | $GPG --import
72 if [ $ADDED = 0 ]; then
73 echo >&2 "Key '$add_key' not added. It is not signed with a master key"
78 # update the current archive signing keyring from a network URI
79 # the archive-keyring keys needs to be signed with the master key
80 # (otherwise it does not make sense from a security POV)
82 if [ -z "$ARCHIVE_KEYRING_URI" ]; then
83 echo >&2 "ERROR: Your distribution is not supported in net-update as no uri for the archive-keyring is set"
87 # in theory we would need to depend on wget for this, but this feature
88 # isn't useable in debian anyway as we have no keyring uri nor a master key
89 if ! which wget
>/dev
/null
2>&1; then
90 echo >&2 "ERROR: an installed wget is required for a network-based update"
93 if [ ! -d /var
/lib
/apt
/keyrings
]; then
94 mkdir -p /var
/lib
/apt
/keyrings
96 keyring
=/var
/lib
/apt
/keyrings
/$(basename $ARCHIVE_KEYRING)
98 if [ -e $keyring ]; then
99 old_mtime
=$(stat -c %Y $keyring)
101 (cd /var
/lib
/apt
/keyrings
; wget
-q -N $ARCHIVE_KEYRING_URI)
102 if [ ! -e $keyring ]; then
105 new_mtime
=$(stat -c %Y $keyring)
106 if [ $new_mtime -ne $old_mtime ]; then
107 echo "Checking for new archive signing keys now"
108 add_keys_with_verify_against_master_keyring
$keyring $MASTER_KEYRING
113 if [ ! -f $ARCHIVE_KEYRING ]; then
114 echo >&2 "ERROR: Can't find the archive-keyring"
115 echo >&2 "Is the debian-archive-keyring package installed?"
120 # add new keys from the package;
122 # we do not use add_keys_with_verify_against_master_keyring here,
123 # because "update" is run on regular package updates. A
124 # attacker might as well replace the master-archive-keyring file
125 # in the package and add his own keys. so this check wouldn't
126 # add any security. we *need* this check on net-update though
127 $GPG_CMD --quiet --batch --keyring $ARCHIVE_KEYRING --export | $GPG --import
129 if [ -r "$REMOVED_KEYS" ]; then
130 # remove no-longer supported/used keys
131 keys
=`$GPG_CMD --keyring $REMOVED_KEYS --with-colons --list-keys | grep ^pub | cut -d: -f5`
133 if $GPG --list-keys --with-colons | grep ^pub
| cut
-d: -f5 | grep -q $key; then
134 $GPG --quiet --batch --delete-key --yes ${key}
138 echo "Warning: removed keys keyring $REMOVED_KEYS missing or not readable" >&2
144 echo "Usage: apt-key [--keyring file] [command] [arguments]"
146 echo "Manage apt's list of trusted keys"
148 echo " apt-key add <file> - add the key contained in <file> ('-' for stdin)"
149 echo " apt-key del <keyid> - remove the key <keyid>"
150 echo " apt-key export <keyid> - output the key <keyid>"
151 echo " apt-key exportall - output all trusted keys"
152 echo " apt-key update - update keys using the keyring package"
153 echo " apt-key net-update - update keys using the network"
154 echo " apt-key list - list keys"
155 echo " apt-key finger - list fingerprints"
156 echo " apt-key adv - pass advanced options to gpg (download key)"
158 echo "If no specific keyring file is given the command applies to all keyring files."
161 # Determine on which keyring we want to work
162 if [ "$1" = "--keyring" ]; then
163 #echo "keyfile given"
166 if [ -r "$TRUSTEDFILE" ] || [ "$2" = 'add' ] || [ "$2" = 'adv' ]; then
167 GPG
="$GPG --keyring $TRUSTEDFILE --primary-keyring $TRUSTEDFILE"
169 echo >&2 "Error: The specified keyring »$TRUSTEDFILE« is missing or not readable"
173 # otherwise use the default
175 #echo "generate list"
176 TRUSTEDFILE
="/etc/apt/trusted.gpg"
177 eval $(apt-config shell TRUSTEDFILE Apt::GPGV::TrustedKeyring)
178 eval $(apt-config shell TRUSTEDFILE Dir::Etc::Trusted/f)
179 if [ -r "$TRUSTEDFILE" ]; then
180 GPG
="$GPG --keyring $TRUSTEDFILE"
182 GPG
="$GPG --primary-keyring $TRUSTEDFILE"
183 TRUSTEDPARTS
="/etc/apt/trusted.gpg.d"
184 eval $(apt-config shell TRUSTEDPARTS Dir::Etc::TrustedParts/d)
185 if [ -d "$TRUSTEDPARTS" ]; then
187 for trusted
in $(run-parts --list $TRUSTEDPARTS --regex '^.*\.gpg$'); do
188 #echo "part -> $trusted"
189 GPG
="$GPG --keyring $trusted"
193 #echo "COMMAND: $GPG"
196 if [ -z "$command" ]; then
202 if [ "$command" != "help" ] && ! which gpg
>/dev
/null
2>&1; then
203 echo >&2 "Warning: gnupg does not seem to be installed."
204 echo >&2 "Warning: apt-key requires gnupg for most operations."
211 init_keyring
"$TRUSTEDFILE"
212 $GPG --quiet --batch --import "$1"
217 init_keyring
"$TRUSTEDFILE"
218 $GPG --quiet --batch --delete-key --yes "$1"
222 init_keyring
"$TRUSTEDFILE"
226 init_keyring
"$TRUSTEDFILE"
230 init_keyring
"$TRUSTEDFILE"
231 $GPG --batch --list-keys
234 init_keyring
"$TRUSTEDFILE"
235 $GPG --batch --fingerprint
238 init_keyring
"$TRUSTEDFILE"
239 $GPG --armor --export "$1"
242 init_keyring
"$TRUSTEDFILE"
243 $GPG --armor --export
246 init_keyring
"$TRUSTEDFILE"
247 echo "Executing: $GPG $*"